
Katello - Bug #4715

Pulp task action fails occasionally with 404 from Pulp task API

03/19/2014 04:32 PM - Ivan Necas

Status: Closed   

Priority: Normal   

Assignee: Ivan Necas   

Category:    

Target version: Katello 2.0   

Difficulty:  Fixed in Releases:  

Triaged: Yes Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Hit this when publishing large content view:

105: Actions::Pulp::Repository::RegenerateApplicability (success)

Input:

---

pulp_id: ACME_Corporation-Library-rhel-Red_Hat_Enterprise_Linux_Server-Red_Hat_Enterprise_Linux_6_

Server_Kickstart_x86_64_6Server

remote_user: admin

Output:

---

pulp_task:

  task_group_id: 

  exception: 

  traceback: 

  _href: /pulp/api/v2/tasks/012be1a0-4376-46d1-b4bc-098447041deb/

  task_id: 012be1a0-4376-46d1-b4bc-098447041deb

  call_request_tags:

  - pulp:action:applicability_regeneration

  reasons: []

  start_time: '2014-03-19T16:01:09Z'

  tags:

  - pulp:action:applicability_regeneration

  state: finished

  finish_time: '2014-03-19T16:01:09Z'

  dependency_failures: {}

  schedule_id: 

  progress: {}

  call_request_group_id: 

  call_request_id: 012be1a0-4376-46d1-b4bc-098447041deb

  principal_login: admin

  response: accepted

  result: 

Error:

RestClient::ResourceNotFound

404 Resource Not Found

---

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/abstract_response.rb:4

8:in

  `return!'

- /opt/rh/ruby193/root/usr/share/gems/gems/runcible-1.0.8/lib/runcible/base.rb:97:in
  `block in get_response'

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:218:in

  `call'

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:218:in

  `process_result'

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:169:in

  `block in transmit'

- /opt/rh/ruby193/root/usr/share/ruby/net/http.rb:746:in `start'

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:166:in

  `transmit'

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:60:in

  `execute'

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/request.rb:31:in

  `execute'

- /opt/rh/ruby193/root/usr/share/gems/gems/rest-client-1.6.1/lib/restclient/resource.rb:51:in

  `get'

- /opt/rh/ruby193/root/usr/share/gems/gems/runcible-1.0.8/lib/runcible/base.rb:96:in

  `get_response'

- /opt/rh/ruby193/root/usr/share/gems/gems/runcible-1.0.8/lib/runcible/base.rb:87:in

  `call'

- /opt/rh/ruby193/root/usr/share/gems/gems/runcible-1.0.8/lib/runcible/resources/task.rb:43:in

  `poll'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/pulp/abstract_async_task.

rb:41:in

  `poll_external_task'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action/polling.rb:12:in

  `run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:422:in

  `block (3 levels) in execute_run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/middleware/stack.rb:26:in

  `call'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/middleware/stack.rb:26:in

  `pass'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/middleware.rb:16:in

  `pass'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/middleware/remote_action.

rb:13:in

  `block in run'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/middleware/remote_action.

rb:39:in

  `block (2 levels) in as_remote_user'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/katello/util/thread_session.rb:85

:in

  `set_pulp_config'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/middleware/remote_action.

rb:29:in

  `as_pulp_user'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/middleware/remote_action.

rb:38:in

  `block in as_remote_user'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/katello/util/thread_session.rb:92

:in

  `set_cp_config'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/middleware/remote_action.

rb:24:in

  `as_cp_user'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/middleware/remote_action.

rb:37:in

  `as_remote_user'

- /opt/rh/ruby193/root/usr/share/gems/gems/katello-1.5.0/app/lib/actions/middleware/remote_action.

rb:13:in

  `run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/middleware/stack.rb:22:in

  `call'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/middleware/world.rb:30:in

  `execute'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:422:in
  `block (2 levels) in execute_run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:421:in

  `catch'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:421:in

  `block in execute_run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:351:in

  `call'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:351:in

  `block in with_error_handling'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:351:in

  `catch'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:351:in

  `with_error_handling'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:420:in

  `execute_run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/action.rb:220:in

  `execute'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/execution_plan/steps/abstract

_flow_step.rb:9:in

  `block (2 levels) in execute'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/execution_plan/steps/abstract

.rb:119:in

  `call'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/execution_plan/steps/abstract

.rb:119:in

  `with_time_calculation'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/execution_plan/steps/abstract

_flow_step.rb:8:in

  `block in execute'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/execution_plan/steps/abstract

_flow_step.rb:27:in

  `open_action'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/execution_plan/steps/abstract

_flow_step.rb:7:in

  `execute'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/executors/parallel/worker.rb:

20:in

  `block in on_message'

- /opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:859:in

  `block in assigns'

- /opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:858:in

  `tap'

- /opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:858:in

  `assigns'

- /opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:138:in

  `match_value'

- /opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:116:in

  `block in match'

- /opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:115:in

  `each'

- /opt/rh/ruby193/root/usr/share/gems/gems/algebrick-0.4.0/lib/algebrick.rb:115:in

  `match'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/executors/parallel/worker.rb:

17:in

  `on_message'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:82:in

  `on_envelope'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:72:in

  `receive'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:99:in

  `block (2 levels) in run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:99:in

  `loop'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:99:in

  `block in run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:99:in

  `catch'
- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:99:in

  `run'

- /opt/rh/ruby193/root/usr/share/gems/gems/dynflow-0.5.1/lib/dynflow/micro_actor.rb:13:in

  `block in initialize'

- /opt/rh/ruby193/root/usr/share/gems/gems/logging-1.8.1/lib/logging/diagnostic_context.rb:323:in

  `call'

- /opt/rh/ruby193/root/usr/share/gems/gems/logging-1.8.1/lib/logging/diagnostic_context.rb:323:in

  `block in create_with_logging_context'

 Probably Pulp moved the task to archived (and the path to API changed) before Katello

got the finished state from the API.

After resuming the process from Dynflow console, the task went successfully and the publishing

finished

Associated revisions

Revision 901b3030 - 03/25/2014 01:10 PM - Ivan Necas

Update foreman-tasks

Fixes #4762

Fixes #4741

Fixes #4715

Pre-requisite for #4781.

Also, it brings significant performance improvements with new Dynflow.

History

#1 - 03/20/2014 10:05 AM - Ivan Necas

- Status changed from New to Assigned

#2 - 03/20/2014 10:05 AM - Ivan Necas

- Assignee set to Ivan Necas

#3 - 03/21/2014 08:05 PM - Mike McCune

- Triaged set to Yes

#4 - 03/21/2014 08:21 PM - Mike McCune

- Triaged deleted (Yes)

#5 - 03/21/2014 09:05 PM - Mike McCune

- Triaged set to Yes

#6 - 03/25/2014 01:52 PM - Ivan Necas

- Status changed from Assigned to Closed

- % Done changed from 0 to 100

Applied in changeset katello|commit:901b303057a13fa177b588f47e6b9010d82bc61e.

#7 - 08/21/2014 02:31 PM - Eric Helms

- translation missing: en.field_release set to 13
